using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Buchsaben_einlesen
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        #region Globale Variablen
        int anzahly;
        int anzahlbges;
        int breite;
        int hoehe;
        int size;
        int anzahlb;
        string pfad;

        int[,,] x;

        int[,,] weight;
        int[,,] weighttemp;
        int[] bias;
        int[,] t;

        int[] y_in;
        int[] y;

        int[,] vergleichsbild;

        int[] y_out;

        bool initialisiert = false;
        bool gelernt = false;
        bool initialisiert2=false;
        #endregion
#region Funktionen/Algorithmus
        private void LernBilderEinlesen()
        {
            string Filename = "";     //Variable fr Dateiname
            Bitmap neuesBild = null;  //neues Bild
            x = new int[anzahlbges,breite,hoehe]; //Dem x-Array wird das Format zugewiesen   

            for (int i = 0; i < anzahlbges ; i++) //Schleife luft ber alle Bilder pro Buchstabe
                {
                    /*Der Dateiname wird bei jedem durchlauf dieser Schleifevariiert. whrend die Buchstaben alle Werte von 1-z durchlaufen 
                      werden hier noch die entsprechenden zahlen von 0-zu dem Wert dan man als Bilder pro Buchstabe festgelegt hat.*/
                    Filename = pfad+"\\"+ i +".bmp";
                    /*Das Bild wird geffnet und danach alle Pixel einzeln ausgelesen. ist ein Pixel Schwarz wird an die entsprechende 
                      Stelle im 2D-bildArray der Wert eingetragen*/
                    neuesBild = new Bitmap(Filename);
                    
                    for (int b = 0; b < neuesBild.Size.Width; b++)
                    {
                        for (int h = 0; h < neuesBild.Size.Height; h++)
                        {
                            #region Strigzerlegen
                            int bstelle = neuesBild.GetPixel(b, h).ToString().IndexOf("R=");
                            int ende = neuesBild.GetPixel(b, h).ToString().IndexOf(",", bstelle);
                            string endtext = neuesBild.GetPixel(b, h).ToString().Remove(0, bstelle + 2);
                            string endtext2 = endtext.Remove(1);
                            int wert = int.Parse(endtext2);
                            #endregion
                           
                            if (wert != 0)
                            {
                                wert = -1;
                            }
                            else
                            {
                                wert = 1;
                            }
                            x[i,b,h] = wert;
                        }
                    }
                }
            }
        private void InputWertesetzen()
        {
            t = new int[anzahly, anzahlbges];
            int buchstabenzaehler = 0 ;
            

            for (int i = 0; i < anzahlbges; i += anzahlb) //Schleife ber Bilder Pro Buchstabe
            {
                for (int u = 0; u < anzahly; u++) //Schleife ber Buchstabe A-Z
                {
                    for (int k = i; k < i + anzahlb; k++) //Scheife die vom ersten richtigen Bild jedes Buchstaben bis zum letzten luft
                    {
                        if (buchstabenzaehler == u) t[u, k] = 1; // wenn j den Buchstaben erreicht den buchtabenzaehler gerade gespeichert het werden fr alle bilder die fr diesen Buchstaben richtig sind der Wert 1 gesetzt
                        else t[u, k] = -1; //fr alle anderen Bilder wird bei diesem Buchstaben der INpuWert auf -1 gesetzt
                    }
                }
                buchstabenzaehler++; // zhlt fr welchen Buchstaben Werte geschrieben werden
            }
          
        }
        private void Lernen()
        {
            y_in = new int[anzahly];
            weight = new int[anzahly,breite,hoehe];
            weighttemp = new int[anzahly,breite,hoehe];
            bias = new int[anzahly];
            y = new int[anzahly];
            bool abbruch = false;
            int abbruchzaehler = 0;
         while (!abbruch)  
         { 
             for (int i = 0; i < anzahlbges; i++)
            {
            for (int u = 0; u < anzahly; u++) 
            {
                
                y_in[u] = 0;
                  
                   for (int b = 0; b < breite; b++)
                    {
                        for (int h = 0; h < hoehe; h++)
                        {
                            y_in[u] = y_in[u] + (x[i, b, h] * weight[u, b, h]);
                            weighttemp[u,b,h]=weight[u,b,h];
                        }
                    }
                    y_in[u]+= bias[u];
                    if (y_in[u] >= 0) y[u] = 1;
                    else y[u] = -1;
                    
                }
               
                for (int u = 0; u < anzahly; u++) 
                {
                   if (t[u, i] != y[u])
                    {
                       for (int b = 0; b < breite; b++)
                         {
                            for (int h = 0; h < hoehe; h++)
                                 {
                                     bias[u] = bias[u] + t[u, i];
                                     
                                     weight[u, b, h] = weight[u, b, h] + (t[u, i] * x[i, b, h]);
                                    
                                 }
                         }
                         
                    }
                }
            }

            for (int u = 0; u < anzahly; u++)
            {
                for (int b = 0; b < breite; b++)
                {
                    for (int h = 0; h < hoehe; h++)
                    {
                        if (weighttemp[u, b, h] == weight[u, b, h]) abbruchzaehler++;
                    }
                }
            }
            if (abbruchzaehler == anzahly * size) abbruch = true;
            else abbruchzaehler = 0;
        }
        
        }
        private void VergleichsBildEinlesen()
        {
          
            OpenFileDialog opf = new OpenFileDialog(); //Ein "OpenFileDialog" wird geffnet und man liest dadurch den Dateinamen des zu vergleichenden Bildes ein
            Bitmap neuesBild = null;                   //Das neue Bild wird definiert;
            if (opf.ShowDialog() == DialogResult.OK)   //berprfung ob die Eingabe im OpenFileDialog Korrekt war
            {
             
                neuesBild = new Bitmap(Image.FromFile(opf.FileName)); //Dateiname des Bildes wird aus dem OpenFileDialog von vorhin bezogen
                if (neuesBild.Size.Width==breite && neuesBild.Size.Height == hoehe)
                {
                    vergleichsbild = new int[breite,hoehe];

                    for (int b = 0; b < neuesBild.Size.Width; b++)
                    {
                        for (int h = 0; h < neuesBild.Size.Height; h++)
                        {
                            /*Selbes Verfahren wie in der vorherigen Funktion. Pixel werden einzeln auf Schwarz/Wei geprft und Werte in bildArray geschrieben*/
                            #region Stringzerlegung
                            int bstelle = neuesBild.GetPixel(b, h).ToString().IndexOf("R=");
                            int ende = neuesBild.GetPixel(b, h).ToString().IndexOf(",", bstelle);
                            string endtext = neuesBild.GetPixel(b, h).ToString().Remove(0, bstelle + 2);
                            string endtext2 = endtext.Remove(1);
                            int wert = int.Parse(endtext2);
                            #endregion
                            if (wert != 0)
                            {
                                wert = -1;
                            }
                            else
                            {
                                wert = 1;
                            }
                            vergleichsbild[b,h] = wert;
                        }
                    }
                }
            }
          
        }
        private void BildVergleichen()
        {   
            y_out = new int[anzahly];
            for (int u = 0; u < anzahly; u++)
            {
                for (int b = 0; b < breite; b++)
                {
                    for (int h = 0; h < hoehe; h++)
                    {
                        y_out[u] += vergleichsbild[b, h] * weight[u, b, h];
                    }
                }
                y_out[u] += bias[u];
                
                if (y_out[u] >= 0) y_out[u] = 1;
                else  y_out[u] = -1;
            }
        }
#endregion
        private void initalisierButton_Click(object sender, EventArgs e)
        {
            if (!initialisiert2)
            {
                #region initialisiervorgang
                anzahly = Convert.ToInt32(anzahlyBox.Text);
                anzahlb = Convert.ToInt32(anzahlbBox.Text);
                breite = Convert.ToInt32(breiteBox.Text);
                hoehe = Convert.ToInt32(hoeheBox.Text);
                size = breite * hoehe;
                anzahlbges = anzahlb * anzahly;
                anzahlyBox.ReadOnly = true;
                anzahlbBox.ReadOnly = true;
                breiteBox.ReadOnly = true;
                hoeheBox.ReadOnly = true;
                LernenButton.Enabled = true;
                initialisiert = true;
                initialisiert2 = true;
                #endregion
            }
            else MessageBox.Show("Sie knnen nur einmal Initialisieren!");
        }

        private void LernenButton_Click(object sender, EventArgs e)
        {
          
            
            if (initialisiert)
            {
                
                
                LernBilderEinlesen();
                InputWertesetzen();
                Lernen();
 
                gelernt = true;
               
            }
            else MessageBox.Show("Bitte zuerst mit den richtigen Werten initialisieren");
            
        }

        private void vergleichButton_Click(object sender, EventArgs e)
        {
            if (gelernt)
            {
                VergleichsBildEinlesen();

                BildVergleichen();

                for (int u = 0; u < anzahly; u++)
                {

                    if (y_out[u] == 1)
                    {
                        if (u < 26) outputBox.Text = outputBox.Text + Convert.ToChar(u + 65).ToString();
                        else if (u == 26) outputBox.Text = "weies Bild";
                        else if (u == 27) outputBox.Text = "schwarzes Bild";
                    }
                }
                initialisiert = false;
            }
            else MessageBox.Show("Bitte zuerst den Lernvorgang durchfhren!");
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog fbd = new FolderBrowserDialog();
            if (fbd.ShowDialog() == DialogResult.OK)
            {
                pfad = fbd.SelectedPath.ToString();
                initalisierButton.Enabled = true;
                pfadBox.Text = pfad;
                pfadBox.TextAlign= HorizontalAlignment.Left;
                button1.Enabled = false;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            initalisierButton.ForeColor = Color.White;
            LernenButton.ForeColor = Color.White;
            vergleichButton.ForeColor = Color.White;
        }


    }
}